Bug 139359

Summary: [GTK] Layout test inspector-protocol/debugger/setBreakpoint-dfg-callee-and-examine-dfg-local.html is flaky
Product: WebKit Reporter: Carlos Alberto Lopez Perez <clopez>
Component: WebKitGTKAssignee: Yury Semikhatsky <yurys>
Status: RESOLVED FIXED    
Severity: Normal CC: bugs-noreply, commit-queue, drousso, ggaren, msaboff, yurys
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Attachments:
Description Flags
Patch
none
Patch for landing
none
Patch for landing none

Description Carlos Alberto Lopez Perez 2014-12-07 04:27:54 PST
Layout test inspector-protocol/debugger/setBreakpoint-dfg-callee-and-examine-dfg-local.html is flaky (fails sometimes) since it was added in r176479 <http://trac.webkit.org/r176479>


When it fails, the diff is:

--- /home/clopez/webkit/webkit/layout-test-results/inspector-protocol/debugger/setBreakpoint-dfg-callee-and-examine-dfg-local-expected.txt
+++ /home/clopez/webkit/webkit/layout-test-results/inspector-protocol/debugger/setBreakpoint-dfg-callee-and-examine-dfg-local-actual.txt
@@ -13,8 +13,8 @@
 Response value is 12
 Evaluating in DFG frame at frame[2]: 'localVal3'
 Response value is 12
-Resumed from breakpoint
 inside breakpointBasic
 result: 42
+Resumed from breakpoint
 Test complete

https://build.webkit.org/results/GTK%20Linux%2064-bit%20Release%20%28Tests%29/r176918%20%284672%29/inspector-protocol/debugger/setBreakpoint-dfg-callee-and-examine-dfg-local-pretty-diff.html
Comment 1 Carlos Alberto Lopez Perez 2014-12-07 08:15:17 PST
Marked accordingly on the GTK expectations on https://trac.webkit.org/r176922
Comment 2 Yury Semikhatsky 2019-10-10 14:30:15 PDT
Created attachment 380683 [details]
Patch
Comment 3 Devin Rousso 2019-10-25 15:39:58 PDT
Comment on attachment 380683 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=380683&action=review

rs=me, but please run it through EWS one more time since it looks like there were some (possibly unrelated) failures on mac-debug-wk1

> LayoutTests/inspector/debugger/setBreakpoint-dfg-callee-and-examine-dfg-local.html:99
> +                        setTimeout(function (responseObject) {

What about this?
```
    InspectorProtocol.awaitEvent({event: "Debugger.resumed"}).then(() => {
        ProtocolTest.log("Resumed from breakpoint");
        ProtocolTest.log("Test complete");
        ProtocolTest.completeTest();
    });
    InspectorProtocol.sendCommand("Debugger.resume");
```
Comment 4 Yury Semikhatsky 2019-10-25 22:25:17 PDT
Comment on attachment 380683 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=380683&action=review

>> LayoutTests/inspector/debugger/setBreakpoint-dfg-callee-and-examine-dfg-local.html:99
>> +                        setTimeout(function (responseObject) {
> 
> What about this?
> ```
>     InspectorProtocol.awaitEvent({event: "Debugger.resumed"}).then(() => {
>         ProtocolTest.log("Resumed from breakpoint");
>         ProtocolTest.log("Test complete");
>         ProtocolTest.completeTest();
>     });
>     InspectorProtocol.sendCommand("Debugger.resume");
> ```

Yes,  this will work, because Debugger.resumed is sent after exiting from the nested loop. Updated the test.
Comment 5 Yury Semikhatsky 2019-10-25 22:26:31 PDT
Created attachment 381997 [details]
Patch for landing
Comment 6 Yury Semikhatsky 2019-10-25 22:27:48 PDT
Created attachment 381998 [details]
Patch for landing
Comment 7 WebKit Commit Bot 2019-10-25 23:12:21 PDT
Comment on attachment 381998 [details]
Patch for landing

Clearing flags on attachment: 381998

Committed r251628: <https://trac.webkit.org/changeset/251628>
Comment 8 WebKit Commit Bot 2019-10-25 23:12:23 PDT
All reviewed patches have been landed.  Closing bug.